
#define DRIVER_NAME			"watchdog" 
#define MAX_TIMER_CTRS 		9

#define KERNL_WDT_MINOR		0
#define APP_WDT_MINOR			1

/*Size allocated for 0-8  Timer Control Register */
#define WDT_REG_SIZE			512
#define WDT_BASE_OFFSET		0xB0200100

#define TIMER_0					WDT_BASE_OFFSET
#define TIMER_1					WDT_BASE_OFFSET+0x20
#define TIMER_2					WDT_BASE_OFFSET+0x40
#define TIMER_3					WDT_BASE_OFFSET+0x60
#define WDT_TIMER_4			WDT_BASE_OFFSET+0x80
#define TIMER_5					WDT_BASE_OFFSET+0xA0
#define TIMER_6					WDT_BASE_OFFSET+0xC0
#define TIMER_7					WDT_BASE_OFFSET+0xE0
#define WDT_TIMER_8			WDT_BASE_OFFSET+0x100	

#if 0
/*Timer Control Registers*/
#define TICX ((unsigned long *)(((unsigned long) wdt_remap_addr)+0x00))  
#define TCCX ((unsigned long *)(((unsigned long) wdt_remap_addr)+0x04))
#define TMCX ((unsigned long *)(((unsigned long) wdt_remap_addr)+0x10))
#define TISX ((unsigned long *)(((unsigned long) wdt_remap_addr)+0x14))
#endif 

/*Timer Control Registers*/
#define TICX 						0x00  
#define TCCX 						0x04
#define TMCX 					0x10
#define TISX 						0x14

/*Timer Mode Control Register (TMC)*/
#define WTM						(0x02)       		// Watchdog Timer Mode
#define TE   						(0x01)			// Timer Enable

/*Timer Interrupt Status (TIS)*/
#define TIS						(0x01)			//Timer Interrupt Status
#define TIE						(0x00)			//Timer Interrupt Enable 



/* Interrupt Observer Register */

/* 6-15 bits of this register holds Interrupt status of (0-8)Timer status */
#define INT_OBSERVE_REG 		0xB02008F8

#define TIS0 						1<<6
#define TIS1 						1<<7
#define TIS2 						1<<8
#define TIS3 						1<<9
#define TIS4 						1<<10
#define TIS5 						1<<11
#define TIS6 						1<<12
#define TIS7 						1<<13
#define TIS8 						1<<14
#define TIS9 						1<<15

/* POS REGISTER */
#define POS_REG					0xB02008A8
#define SRAM_REG				0xB0005000
#define SRAM_WDT_STATE          0xB0005010

/*KCS REGISTER*/
#define KCS2_DATA				0xB0200E00
#define KCS2_STATUS				0xB0200E04
#define KCS2_CMD				0xB0200E08
#define KCS2_MODE				0xB0200E0C

/* KCS Intr IBF and OBF enable mask*/
#define INTR_EN_MASK		0x06


/*Timer mode */
#define TMR_MODE				0x01
#define WDT_MODE				0x02

/*Watchdog Timers */
#define KERNEL_WDT				0x21
#define APP_WDT					0x22



#define    COUNT_VAL_8_SEC 		0x2FAF0800
#define    COUNT_VAL_10_SEC 	       0x3B9ACA00

typedef unsigned long   UINT32;

/****This is the structure that is passed back and forth between userspace and driver as an ioctl arg*****/
/*This structure for configuration of  Watchdog Timer  */
typedef struct 
{	
	unsigned short Mode ;					/*Timer or watchdog  */
	unsigned short WdtType;                 		/* Watchdog 0 -kernel Watchdog  1 -Application Watchdog */
	unsigned short TmrNum;                         		/* Configure  timer (0-9) */
	unsigned long PreTimeOutInterval;  		/**< Pre Timeout interval */
	unsigned long TimeInterval;				/**<  Timeout interval */
	unsigned short TmrAction;				/**<  Timeout Action */
	unsigned short  TimerUse;				/**<  Timer Use */
} __attribute__((packed))TmrWdtConfig_T;	

typedef enum {
	WDT_KEEPALIVE,
	WDT_TMR_ENABLE,
	WDT_TMR_DISABLE,
	WDT_TMR_SETCONFIG,
	WDT_TMR_GETCONFIG,
	WDT_TMR_GET_CUR_CNT
}eTmrWdtFunc;














