/*
 * (C) Copyright 2006
 * Samvinesh Christopher,  American Megatrends Inc, vineshc@ami.com
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

/* Mips Coprocessor Commands */

#include <common.h>
#include <config.h>
#include <command.h>
#include <asm/mipsregs.h>

#if defined(CONFIG_MIPS)

#if 0

static
unsigned long
ReadC0(unsigned short reg, unsigned short sel)
{
	unsigned long c0reg = ((unsigned long)reg) | (((unsigned long)sel) << 16);
	unsigned val;

	val = read_32bit_cp0_register(c0reg);
	return val;
}


static
void
WriteC0(unsigned short reg, unsigned short sel,unsigned long val)
{
	unsigned long c0reg = ((unsigned long)reg) | (((unsigned long)sel) << 16);

	write_32bit_cp0_register(c0reg,val);
	return;
}





int 
do_getc0 ( cmd_tbl_t *cmdtp, int flag, int argc, char *argv[] )
{
	unsigned short reg,sel;	
	unsigned long value;	


	/* Validate arguments */
	if (argc < 2) {
		printf ("Usage:\n%s\n", cmdtp->usage);
		return 1;
	}

	reg = (unsigned short) simple_strtoul (argv[1], NULL, 16);
	if (argc == 3)
		sel = (unsigned short) simple_strtoul (argv[2], NULL, 16);
	else
		sel = 0;

	value = ReadC0 (reg,sel);

	printf ("C0 Register 0x%04x, Select 0x%04X = 0x%08lx\n", reg,sel, value);

	return 0;
}


int 
do_setc0 (cmd_tbl_t * cmdtp, int flag, int argc, char *argv[])
{
	unsigned short reg,sel;	
	unsigned long value;	

	int nbytes;
	extern char console_buffer[];

	/* Validate arguments */
	if (argc < 2) {
		printf ("Usage:\n%s\n", cmdtp->usage);
		return 1;
	}

	reg = (unsigned short) simple_strtoul (argv[1], NULL, 16);
	if (argc == 3)
		sel = (unsigned short) simple_strtoul (argv[2], NULL, 16);
	else
		sel = 0;

	/* Set the value */
	do {
		value = ReadC0 (reg,sel);
		printf ("C0 Register 0x%04x, Select 0x%04X = 0x%08lx\n", reg,sel,value);
		nbytes = readline (" ? ");
		if (nbytes == 0) 
		{
			/*
			 * <CR> pressed as only input, don't modify current
			 * location and exit command.
			 */
			nbytes = 1;
			return 0;
		} 
		else 
		{
			unsigned long i;
			char *endp;

			i = simple_strtoul (console_buffer, &endp, 16);
			nbytes = endp - console_buffer;
			if (nbytes)
				WriteC0 (reg,sel,i);
		}
	} while (nbytes);

	return 0;
}


U_BOOT_CMD(
	getc0,	2,	1,	do_getc0,
	"getc0  - Get a MIPS Coprocessr 0 value\n",
	"reg <sel> - return a MIPS CO value.\n"
);
U_BOOT_CMD(
	setc0,	2,	1,	do_setc0,
	"setc0  - Set a MIPS Coprocessor 0 value\n",
	"reg <sel> - set a MIPS C0 value.\n" 
);

#endif // #if 0

#define DISPLAY_CP0(x) printf("C0 Register %20s = 0x%08x\n",#x,read_32bit_cp0_register(x))

int 
do_dumpcp0 ( cmd_tbl_t *cmdtp, int flag, int argc, char *argv[] )
{
	DISPLAY_CP0( CP0_INDEX );
	DISPLAY_CP0( CP0_RANDOM );
	DISPLAY_CP0( CP0_ENTRYLO0 );
	DISPLAY_CP0( CP0_ENTRYLO1 );
	DISPLAY_CP0( CP0_CONTEXT );
	DISPLAY_CP0( CP0_PAGEMASK );
	DISPLAY_CP0( CP0_WIRED );
	DISPLAY_CP0( CP0_HWRENA );
	DISPLAY_CP0( CP0_BADVADDR );
	DISPLAY_CP0( CP0_COUNT );
	DISPLAY_CP0( CP0_ENTRYHI );
	DISPLAY_CP0( CP0_COMPARE );
	DISPLAY_CP0( CP0_STATUS );
	DISPLAY_CP0( CP0_CAUSE );
	DISPLAY_CP0( CP0_EPC );
	DISPLAY_CP0( CP0_PRID );
	DISPLAY_CP0( CP0_CONFIG );
	DISPLAY_CP0( CP0_LLADDR );
	DISPLAY_CP0( CP0_WATCHLO );
	DISPLAY_CP0( CP0_WATCHHI );
	DISPLAY_CP0( CP0_DEBUG );
	DISPLAY_CP0( CP0_DEBUG_EXE_PC );
	DISPLAY_CP0( CP0_PERFORMANCE );
	DISPLAY_CP0( CP0_ECC );
	DISPLAY_CP0( CP0_TAGLO );
	DISPLAY_CP0( CP0_TAGHI );
	DISPLAY_CP0( CP0_ERROREPC );
	DISPLAY_CP0( CP0_DESAVE );

	return 0;
}

U_BOOT_CMD(
	dumpcp0,	1,	1,	do_dumpcp0,
	"dumpcp0  - Dump MIPS Coprocessor 0 values\n",
	"Dump MIPS C0 value.\n" 
);

#endif 
